// Ball.java
// Created: Wednesday, September 22, 1999 9:52:48 PM

package ballworld;

/**
 * The Ball interface describes methods that a Ball presents to other objects.
 * Classes that you define will implement Ball by defining the methods that are
 * declared here.
 *
 * @author (previous author unknown)
 * @author Patrick G. Heck, gus.heck@olin.edu
 * @version $Id: Ball.java,v 1.2 2003/09/11 21:35:37 gus Exp $
 */
public interface Ball
{
	/** Returns the current horizontal location of the Ball
         * @return The horizontal location
         */
	public double getX();
	
	/** Returns the current vertical location of the Ball
         * @return The vertical location
         */
	public double getY();

	/** Returns the current radius of the Ball
         * @return The radius
         */
	public double getRadius();

	/** This method will be called by our setup code shortly after your Ball is created.
         * If you would like to use the World object to get information about the world,
         * then you should store the parameter of this method somewhere safe.
         * @param theWorld A world object that contains this ball
         */
	public void setWorld(World theWorld);
	
	/**
         * Process a click from the mouse. This method is called if the user selects
         * this particular ball and then clicks or drags the mouse somewhere.
         * The atX and atY parameters are the location that the user released
         * the mouse button.
         *
         * @param atX The x coordinate of the user's click
         * @param atY The y coordinate of the user's click
         */
	public void userClicked(double atX, double atY);

	/** This method is called if the user selects this particualr ball and then types a
         * key.  The key that the user typed is passed as the parameter.  Note that not
         * all keys on the keyboard will cause this method to get called -- only those keys
         * that have a printable form.  (For instance, the 'J' or space key will trigger this
         * method, but the arrow and function keys may not.)
         * @param key The character from the key that the user typed.
         */
	public void userTyped(char key);
}

/*
 * $Log: Ball.java,v $
 * Revision 1.2  2003/09/11 21:35:37  gus
 * change package name
 *
 * Revision 1.1  2003/02/10 14:50:16  gus
 * A complete rewrite of the old ballworld.
 *
 */
