/*
 * BallWorld.java
 *
 * Created on February 7, 2003, 1:58 PM
 */

package ballworld;

import cs101.lang.AnimatorThread;

import java.io.File;

import java.awt.Component;
import java.awt.Container;

import java.net.URL;
import java.net.URLClassLoader;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JFileChooser;

import java.awt.event.MouseEvent;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.ActionListener;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

/**
 * Provides a GUI for the BallWorld to live in.
 *
 * @author Patrick G. Heck, gus.heck@olin.edu
 * @version $Id: BallWorldGUI.java,v 1.4 2004/02/04 22:58:20 gus Exp $
 */
public class BallWorldGUI extends javax.swing.JFrame {
    
    BallWorld ourWorld;
    Thread spaceTime;
    ClassLoader cl = Thread.currentThread().getContextClassLoader();
    URLClassLoader uLoad = new URLClassLoader(new URL[] {}, cl);
    
    /** Creates new form BallWorld */
    public BallWorldGUI() {
        ourWorld = new BallWorld();
        initComponents();
        spaceTime = new Thread(ourWorld);
        spaceTime.start();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        worldPanel = new javax.swing.JPanel();
        buttonPanel = new javax.swing.JPanel();
        jMenuBar1 = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        loadMenuItem = new javax.swing.JMenuItem();
        expandClasspathMenuItem = new javax.swing.JMenuItem();
        exitMenuItem = new javax.swing.JMenuItem();

        setTitle("Ball World");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanel1.setLayout(new java.awt.GridBagLayout());

        worldPanel.setLayout(new java.awt.GridLayout(1, 0));

        worldPanel.add(ourWorld);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(worldPanel, gridBagConstraints);

        buttonPanel.setLayout(new java.awt.GridLayout(1, 0));

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(buttonPanel, gridBagConstraints);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        fileMenu.setText("File");
        loadMenuItem.setText("Load Ball...");
        loadMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(loadMenuItem);

        expandClasspathMenuItem.setText("Expand Classpath...");
        expandClasspathMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                expandClasspathMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(expandClasspathMenuItem);

        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(exitMenuItem);

        jMenuBar1.add(fileMenu);

        setJMenuBar(jMenuBar1);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-400)/2, (screenSize.height-500)/2, 400, 500);
    }//GEN-END:initComponents
    
    private void expandClasspathMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_expandClasspathMenuItemActionPerformed
        // Add your handling code here:
        String temp = "";
        try {
            JFileChooser chooser = new JFileChooser();
            chooser.setFileFilter(
            new javax.swing.filechooser.FileFilter() {
                public String getDescription() {
                    return "Java Archive (*.jar) or Directory";
                }
                public boolean accept(File f) {
                    return
                    f.getName().matches(".*\\.jar") || f.isDirectory();
                }
            });
            chooser.setFileSelectionMode(
            JFileChooser.FILES_AND_DIRECTORIES);
            chooser.setMultiSelectionEnabled(true);
            int returnVal = chooser.showOpenDialog( BallWorldGUI.this );
            File[] files = chooser.getSelectedFiles();
            URL[] prev = uLoad.getURLs();
            URL[] newURLs = new URL[prev.length + files.length];
            for (int i=0; i < files.length; i++) {
                //System.out.print("new:" + files[i]);
                newURLs[i] = files[i].toURL();
            }
            for (int i=files.length; i < newURLs.length; i++) {
                //System.out.println("old:" + prev[i - files.length]);
                newURLs[i] = prev[i - files.length];
            }
            synchronized (uLoad) {
                uLoad = new URLClassLoader(newURLs, cl);
            }
            
        } catch (java.security.AccessControlException ace) {
            // we're running as an applet
            BallWorldGUI.this.showAppletWarning();
        } catch (Exception e2) {
            e2.printStackTrace();
        }
        
    }//GEN-LAST:event_expandClasspathMenuItemActionPerformed
    
    private void loadMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadMenuItemActionPerformed
        // NOTE TO STUDENTS: If you are reading this and having difficulty
        // understanding it, that is OK. This is a technique called reflection
        // that is beyond the scope of an intro course, but it does
        // a bunch of work to make life easier for you. Basically, I am
        // Asking you for a class name, loading it if it exists, peeking
        // at it's Constructors, and choosing the constructor that
        // takes a single World argument if it exists, otherwise I choose
        // the no arg constructor. If neither constructor exists, I complain
        // bitterly and do nothing for you :). Once I have the class and have
        // chosen a constructor, I set up a button that invokes the
        // constructor when pressed and adds your ball to the Ball World.
        
        String class2Load = JOptionPane.
        showInputDialog("Enter the fully qualified name of a class");
        if (class2Load == null) {
            return;
        }
        String unqualifiedName = class2Load.substring(class2Load.lastIndexOf('.')+1);
        
        // Now try to load the class and find out what constructors exist
        Class studentClass = null;
        Constructor world = null,
        noArg = null;
        try {
            studentClass = Class.forName(class2Load, true, this.uLoad);
            Constructor[] studentConstructors = studentClass.getConstructors();
            for (int i=0;i<studentConstructors.length;i++) {
                System.out.println(studentConstructors[i].toString());
                Class[] params = studentConstructors[i].getParameterTypes();
                for (int j=0;j<params.length;j++) {
                    String name = params[j].getName();
                    if (name.equals("ballworld.World")) {
                        world = studentConstructors[i];
                    }
                }
                if (params.length == 0) {
                    noArg = studentConstructors[i];
                }
            }
        } catch (ClassNotFoundException cnfe) {
            try {
                studentClass = Class.forName("ballworld." + class2Load, true, this.uLoad);
                Constructor[] studentConstructors = studentClass.getConstructors();
                for (int i=0;i<studentConstructors.length;i++) {
                    System.out.println(studentConstructors[i].toString());
                    Class[] params = studentConstructors[i].getParameterTypes();
                    for (int j=0;j<params.length;j++) {
                        String name = params[j].getName();
                        if (name.equals("ballworld.World")) {
                            world = studentConstructors[i];
                        }
                    }
                    if (params.length == 0) {
                        noArg = studentConstructors[i];
                    }
                }
            } catch (ClassNotFoundException cnfe2) {
                JOptionPane.showMessageDialog(this, "Class not found!","Warning",
                JOptionPane.ERROR_MESSAGE);
                System.out.println("Warning student class not found");
            }
        }
        
        Object[] args4selected;
        Constructor selected = null;
        if (world != null) {      // use this one if we have it
            selected = world;
            args4selected = new Object[] {ourWorld};
        } else {
            if (noArg != null) {  // otherwise pick no arg constructor
                selected = noArg;
                args4selected = new Object[] {};
            } else {
                JOptionPane.showMessageDialog(this, "No Valid Constructor!","Warning",
                JOptionPane.ERROR_MESSAGE);
                System.out.println("Class must have a constructor that " +
                "takes zero arguments or takes\njust one argument " +
                "of type ballworld.World");
                return;
            }
        }
        
        // This needs to be final so it can be used in an local class
        final Constructor construct = selected;
        final Object[] args = args4selected;
        System.out.println("Constructor selected = " + construct);
        
        JButton aButton = new JButton(unqualifiedName);
        aButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                Ball stuBall = null;
                try {
                    stuBall = (Ball) construct.newInstance(args);
                } catch (InstantiationException ie) {
                    System.out.println("Failed to instantiate the ball");
                    System.out.println(ie);
                    return;
                } catch (IllegalAccessException iae) {
                    System.out.println("Illegal access instantiating ball");
                    System.out.println(iae);
                    return;
                } catch (InvocationTargetException ite) {
                    System.out.println("Failed to instantiate the ball");
                    System.out.println(ite);
                    return;
                }
                
                ourWorld.addBall(stuBall);
            }
        });
        aButton.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent evt) {
                Component src = (Component)evt.getSource();
                Container parent = src.getParent();
                if ((evt.getModifiers() & MouseEvent.CTRL_MASK) != 0) {
                    buttonPanel.remove(src);
                    parent.getParent().validate();
                }
            }
        });
        buttonPanel.add(aButton);
        this.validate();
    }//GEN-LAST:event_loadMenuItemActionPerformed
    
    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        // Add your handling code here:
        exitForm(new WindowEvent(this,WindowEvent.WINDOW_CLOSING));
    }//GEN-LAST:event_exitMenuItemActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    private void showAppletWarning() {
        Object[] options = { "Cancel" };
        JOptionPane.showOptionDialog(
        null,
        "This action not available when running as an applet.",
        "Network Simulation",
        JOptionPane.DEFAULT_OPTION,
        JOptionPane.WARNING_MESSAGE,
        null, options, options[0]);
    }
    
    /**
     * Entry point for the ballworld problem set.
     *
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new BallWorldGUI().show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenuItem expandClasspathMenuItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JMenuItem loadMenuItem;
    private javax.swing.JPanel worldPanel;
    // End of variables declaration//GEN-END:variables
    
}
