// World.java
// Created: Thursday, September 23, 1999 12:20:41 PM

package ballworld;

/**
 * The World interface describes information that a Ball can get about the World
 */

public interface World
{
	/** Get minimum visible X value of the world.
         * @return The minimum x coordinate
         */
	public double getMinX();

	/** return the minimum visible Y value of the world
         * @return The minimum y coordinate
         */
	public double getMinY();

	/** return the maximum visible X value of the world
         * @return The maximum x coordinate
         */
	public double getMaxX();

	/** return the maximum visible Y value of the world
         * @return The maximum y coordinate
         */
	public double getMaxY();
	
	/** returns the Ball object that is closest to myBall
         * (not including myBall).
         * Be careful!  If there is only one ball on the screen,
         * then this method will return null
         * @param myBall The ball to find neighbors for
         * @return The nearest ball if there is one, <code>null</code> otherwise
         */
	public Ball getClosestBall(Ball myBall);
	
	/** Add a ball to the world
         * @param aNewBall The ball to add
         */
	 public void addBall(Ball aNewBall);
	 
	 /** Remove a ball from the world
          * @param toBeRemoved The ball to remove
          */
	  public void removeBall(Ball toBeRemoved);
}
